/**
 * Copyright (c) 2022 - present TinyVue Authors.
 * Copyright (c) 2022 - present Huawei Cloud Computing Technologies Co., Ltd.
 *
 * Use of this source code is governed by an MIT-style license.
 *
 * THE OPEN SOURCE SOFTWARE IN THIS PRODUCT IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,
 * BUT WITHOUT ANY WARRANTY, WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR
 * A PARTICULAR PURPOSE. SEE THE APPLICABLE LICENSES FOR MORE DETAILS.
 *
 */
import type { ComponentPublicInstance } from '@opentiny/vue-common';
interface ModalOptions {
    id?: string;
    events?: {
        hide?: (params: any) => void;
        confirm?: (params: any) => void;
        show?: (params: any) => void;
    };
    componentType?: 'alert' | 'confirm' | 'message' | 'popconfirm';
    message?: string;
    title?: string;
    showFooter?: boolean;
    type?: string;
    status?: string;
    mask?: boolean;
    lockView?: boolean;
    showHeader?: boolean;
    showClose?: boolean;
    [key: string]: any;
}
interface ModalPromise extends Promise<string> {
    vm?: ComponentPublicInstance;
}
interface TINYModalInstance extends ComponentPublicInstance {
    version: string;
    model: {
        prop: string;
        event: string;
    };
    tiny_mode?: boolean;
    tiny_theme?: string;
    installed: boolean;
    alert: (message: string | ModalOptions, title?: string, options?: ModalOptions) => ModalPromise;
    confirm: (message: string | ModalOptions, title?: string, options?: ModalOptions) => ModalPromise;
    message: (message: string | ModalOptions, title?: string, options?: ModalOptions) => ModalPromise;
    popconfirm: (message: string | ModalOptions, title?: string, options?: ModalOptions) => ModalPromise;
    install: (Vue: any) => void;
}
declare const TINYModalComponent: TINYModalInstance;
export declare function Modal(options: ModalOptions): ModalPromise;
export declare const alert: any;
export declare const message: any;
export declare const confirm: any;
export declare const popconfirm: any;
export default TINYModalComponent;
